﻿Imports System.Collections.ObjectModel

Namespace ViewModel
    Public Class ConsumerListViewModel
        Inherits ViewModelBase


        Public Sub New()
            'Beispieldaten erstellen
            Dim TestDevices As New List(Of Model.Device) From {
                New Model.Device() With {.ID = 1, .Name = "Neonlampe (einfach)", .Description = "keine", .Power = 56}, New Model.Device() With {.ID = 2, .Name = "Neonlampe (doppelt)", .Description = "keine", .Power = 112},
                New Model.Device() With {.ID = 3, .Name = "PC", .Description = "Esprimo", .Power = 230}, New Model.Device() With {.ID = 4, .Name = "Beamer", .Description = "Casio", .Power = 240}}
            Dim TestRooms As New List(Of Model.Room) From {
                New Model.Room() With {.ID = 1, .RoomNumber = "002", .FloorNumber = "0"}, New Model.Room() With {.ID = 2, .RoomNumber = "109", .FloorNumber = "1"},
                New Model.Room() With {.ID = 3, .RoomNumber = "003", .FloorNumber = "0"}, New Model.Room() With {.ID = 4, .RoomNumber = "214", .FloorNumber = "2"}}
            Dim TestDataCollectors As New List(Of Model.DataCollector) From {
                New Model.DataCollector() With {.ID = 1, .Names = "Florian, Simon", .Grade = "9b"}, New Model.DataCollector() With {.ID = 2, .Grade = "9c", .Names = "Lukas, Finn"}}
            Dim TestTimeAreas As New List(Of Model.TimeArea) From {
                New Model.TimeArea() With {.ID = 1, .Name = "Nur an Schultagen"}, New Model.TimeArea() With {.ID = 2, .Name = "Immer an"}}
            Dim TestConsumer As New List(Of Model.Consumer) From {
                New Model.Consumer() With {.ID = 1, .DeviceID = 1, .RoomID = 2, .DeviceCount = 4, .DataCollectorID = 1, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 2, .DeviceID = 3, .RoomID = 1, .DeviceCount = 6, .DataCollectorID = 2, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 3, .DeviceID = 3, .RoomID = 4, .DeviceCount = 3, .DataCollectorID = 2, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 4, .DeviceID = 4, .RoomID = 4, .DeviceCount = 6, .DataCollectorID = 1, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 5, .DeviceID = 3, .RoomID = 2, .DeviceCount = 9, .DataCollectorID = 2, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 5, .DeviceID = 3, .RoomID = 2, .DeviceCount = 9, .DataCollectorID = 1, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 6, .DeviceID = 3, .RoomID = 1, .DeviceCount = 6, .DataCollectorID = 1, .TimeAreaID = 1},
                New Model.Consumer() With {.ID = 7, .DeviceID = 2, .RoomID = 3, .DeviceCount = 9, .DataCollectorID = 2, .TimeAreaID = 2},
                New Model.Consumer() With {.ID = 8, .DeviceID = 4, .RoomID = 2, .DeviceCount = 1, .DataCollectorID = 1, .TimeAreaID = 1}}

            AllConsumers = New ObservableCollection(Of ConsumerViewModel)
            TestConsumer.ForEach(Sub(x) AllConsumers.Add(New ConsumerViewModel(x, (TestDevices, TestRooms, TestDataCollectors, TestTimeAreas))))
            SelectedConsumer = AllConsumers.FirstOrDefault()
        End Sub


        Private _allConsumers As ObservableCollection(Of ConsumerViewModel)
        Public Property AllConsumers As ObservableCollection(Of ConsumerViewModel)
            Get
                Return _allConsumers
            End Get
            Set(ByVal Value As ObservableCollection(Of ConsumerViewModel))
                _allConsumers = Value
                RaisePropertyChanged()
            End Set
        End Property

        Private _selectetConsumer As ConsumerViewModel
        Public Property SelectedConsumer As ConsumerViewModel
            Get
                Return _selectetConsumer
            End Get
            Set(value As ConsumerViewModel)
                _selectetConsumer = value
                RaisePropertyChanged()
            End Set
        End Property

    End Class
End Namespace
