﻿Namespace ViewModel
    Public Class ConsumerViewModel
        Inherits ViewModelBase

        Private ReadOnly _consumerModel As Model.Consumer


        Friend Sub New(consumerModel As Model.Consumer, aviableData As (Devices As List(Of Model.Device), Rooms As List(Of Model.Room), DataCollectors As List(Of Model.DataCollector), TimeAreas As List(Of Model.TimeArea)))
            _consumerModel = consumerModel
            _aviableRooms = aviableData.Rooms
            _aviableDevices = aviableData.Devices
            _aviableTimeAreas = aviableData.TimeAreas
            _AviableDataCollectors = aviableData.DataCollectors

            Device = AviableDevices.Where(Function(x) x.ID = _consumerModel.DeviceId).SingleOrDefault()
            Room = AviableRooms.Where(Function(x) x.ID = _consumerModel.RoomId).SingleOrDefault()
            DataCollector = AviableDataCollectors.Where(Function(x) x.ID = _consumerModel.DataCollectorID).SingleOrDefault()
            TimeArea = AviableTimeAreas.Where(Function(x) x.ID = _consumerModel.TimeAreaID).SingleOrDefault()

            _deviceCount = _consumerModel.DeviceCount
        End Sub


        Public ReadOnly Property ID As Integer
            Get
                Return _consumerModel.ID
            End Get
        End Property




        Private _aviableRooms As List(Of Model.Room)
        Public ReadOnly Property AviableRooms As List(Of Model.Room)
            Get
                Return _aviableRooms
            End Get
        End Property

        Private _aviableDevices As List(Of Model.Device)
        Public ReadOnly Property AviableDevices As List(Of Model.Device)
            Get
                Return _aviableDevices
            End Get
        End Property

        Private _AviableDataCollectors As List(Of Model.DataCollector)
        Public ReadOnly Property AviableDataCollectors As List(Of Model.DataCollector)
            Get
                Return _AviableDataCollectors
            End Get
        End Property

        Private _aviableTimeAreas As List(Of Model.TimeArea)
        Public ReadOnly Property AviableTimeAreas As List(Of Model.TimeArea)
            Get
                Return _aviableTimeAreas
            End Get
        End Property




        Private _room As Model.Room
        Public Property Room As Model.Room
            Get
                Return _room
            End Get
            Set(ByVal Value As Model.Room)
                _room = Value
                _consumerModel.RoomId = Value.ID 'In das 'originale' Modelobjekt die ID zurückgreiben da sich der Raum ja geändert hat
                RaisePropertyChanged()
            End Set
        End Property

        Private _device As Model.Device
        Public Property Device As Model.Device
            Get
                Return _device
            End Get
            Set(ByVal Value As Model.Device)
                _device = Value
                _consumerModel.DeviceId = Value.ID 'In das 'originale' Modelobjekt die ID zurückgreiben da sich das Device ja geändert hat
                RaisePropertyChanged()
            End Set
        End Property


        Private _DataCollector As Model.DataCollector
        Public Property DataCollector As Model.DataCollector
            Get
                Return _DataCollector
            End Get
            Set(value As Model.DataCollector)
                _DataCollector = value
                _consumerModel.DataCollectorID = value.ID
                RaisePropertyChanged()
            End Set
        End Property

        Private _TimeArea As Model.TimeArea
        Public Property TimeArea As Model.TimeArea
            Get
                Return _TimeArea
            End Get
            Set(value As Model.TimeArea)
                _TimeArea = value
                _consumerModel.TimeAreaID = value.ID
                RaisePropertyChanged()
            End Set
        End Property



        Private _deviceCount As Integer
        Public Property DeviceCount As Integer
            Get
                Return _deviceCount
            End Get
            Set(value As Integer)
                _deviceCount = value
                RaisePropertyChanged()
            End Set
        End Property

    End Class
End Namespace
